> This page is for Schema Service, version v3 (latest) (default).
> For other versions, use one of these documentation indexes:
> - v3 (latest) (default): https://autodesk.ferndocs.com/schema/schema-service/v3/llms.txt
> - v2: https://autodesk.ferndocs.com/schema/schema-service/v2/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://autodesk.ferndocs.com/schema/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://autodesk.ferndocs.com/schema/_mcp/server.

# Retrieve All Tags

GET https://developer-stg.api.autodesk.com/schema/v3/tag-collections/{tagCollectionId}/tags

Retrieves all Tags for the Tag Collection specified by the  ``tagCollectionId`` URI parameter.

You can filter the response by category using the ``categoryId`` query string parameter.


Reference: https://autodesk.ferndocs.com/schema/schema-service/api-reference/tags-api/tags/find-all-tags

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Servers

- `https://developer-stg.api.autodesk.com/schema/v3` (The URL for Staging environment, default)
- `https://developer-dev.api.autodesk.com/schema/v3` (The URL for Development environment)
- `https://developer.api.autodesk.com/schema/v3` (The URL for Production environment)

## Request

### Path parameters

- `tagCollectionId` (string, required)

### Query parameters

- `categoryIds` (list of string, optional) — An array of Tag Category IDs. The response will contain only the Tags that belong to the categories you specify. If you do not specify a category, the response returns an empty list of Tags.
- `offset` (integer, optional) — Specifies the first so many items to exclude from the response. Use this parameter with the ``limit`` query parameter to split the response into multiple pages. To fetch the first page, specify ``offset`` =0 (do not exclude any items). To fetch the second page, specify ``offset`` = value of limit you specified for the first page. So, the Tags Service excludes the items returned on the first page. In general, ``offset`` = ``previous_offset`` + ``previous_limit``.This parameter is 0 by default. The minimum value is 0.
- `limit` (integer, optional) — Specifies the maximum number of items to return in a single page. Use this parameter with the ``offset`` query parameter to split the response into multiple pages. To fetch the first page, specify ``offset`` =0 (do not exclude any items). To fetch the second page, specify ``offset`` = value of limit you specified for the first page. So, the Tags Service excludes the items returned on the first page. In general, ``offset`` = ``previous_offset`` + ``previous_limit``.This parameter is 20 by default. The minimum value is 1 and the maximum value is 50

### Headers

- `Region` (enum, optional, default: US) — The Autodesk Schema Registry currently supports in the US and EMEA regions. This header specifies where your data is stored. Possible Values: - ``US`` - (Default) All requests without a specified region header will be directed to the US region. - ``EMEA`` - Data center for the European Union, Middle East, and Africa. To access the EMEA region specifically, include the header "region: EMEA" in your API requests.
  - Allowed values: `US`, `EMEA`

## Response

### 200

The requested data was successfully returned.

- `pagination` (PaginationDetails, optional) — Specifies if the response has been split in to multiple pages, and if so the details.
- `results` (list of TagLite, optional) — An array containing a list of Tags.

## Errors

### 400 Bad Request Error

The Autodesk Schema Registry was not able to decipher your request. Check the request body for malformed request syntax or invalid request message framing before you try again.

- `type` (string, optional) — UTF-8 encoded string
- `title` (string, optional) — UTF-8 encoded string
- `detail` (string, optional) — User-friendly error message.
- `errors` (list of ErrorDetail, optional) — This property will contains relevant error details.

### 401 Unauthorized Error

The request did not have a valid access token. Obtain a fresh access token and try again.

- `type` (string, optional) — UTF-8 encoded string
- `title` (string, optional) — UTF-8 encoded string
- `detail` (string, optional) — User-friendly error message.
- `errors` (list of ErrorDetail, optional) — This property will contains relevant error details.

### 403 Forbidden Error

You do not have permission to perform the operation specified by the request. Contact your LIBRARY_ADMIN and resolve any permission issues before trying this request again.

- `type` (string, optional) — UTF-8 encoded string
- `title` (string, optional) — UTF-8 encoded string
- `detail` (string, optional) — User-friendly error message.
- `errors` (list of ErrorDetail, optional) — This property will contains relevant error details.

### 429 Too Many Requests Error

You have exceeded the Rate Limit for the requested resource. Check the ``retry-after`` response header and send the request again, after the specified time period has elapsed.

- `type` (string, optional) — UTF-8 encoded string
- `title` (string, optional) — UTF-8 encoded string
- `detail` (string, optional) — User-friendly error message.
- `errors` (list of ErrorDetail, optional) — This property will contains relevant error details.

## Types

### PaginationDetails

Specifies if the response has been split in to multiple pages, and if so the details.

- `limit` (integer, optional) — The maximum number of items you requested for this page.
- `offset` (integer, optional) — The first so many items excluded from the response (typically, because they were returned in previous pages).
- `nextUrl` (string, optional) — The link to the next page. This attribute is not returned for the last page.
- `hasNext` (boolean, optional) — ``true`` : This is not the last page. There is at least one more page to return. ``false`` : This is the last page. There are no more pages to return.
- `totalResults` (double, optional) — The total number of items to be returned.

### TagLite

- `id` (string, optional) — A system-generated ID to uniquely identify the Tag.
- `categoryId` (string, optional) — The ID of the Tag Category the Tag belongs to.
- `name` (string, optional) — The name of the Tag.
- `userData` (map from string to TagLiteUserData, optional) — A container for user-defined custom data for the Tag.

### ErrorDetail

Error response model according to the APS standard

- `type` (string, optional) — Specifies the type of the error that occured.
- `title` (string, optional) — Contains a summary of the error.
- `detail` (string, optional) — Contains a detailed description of the error that occured, and sometimes, tips on how to fix the error.

### TagLiteUserData

Key-value pairs of custom data.

## Examples

### Standard

**Response**

```json
{
  "pagination": {
    "limit": 20,
    "offset": 0,
    "nextUrl": "",
    "hasNext": false,
    "totalResults": 2
  },
  "results": [
    {
      "id": "ABVA-50841-HYPY-78617",
      "categoryId": "ABVA-48581-HKHB-90951",
      "name": "Doors"
    },
    {
      "id": "ABVA-50841-HZUG-93173",
      "categoryId": "ABVA-49091-CGZP-54734",
      "name": "Windows"
    }
  ]
}
```

**SDK Code**

```python Standard
import requests

url = "https://developer-stg.api.autodesk.com/schema/v3/tag-collections/tagCollectionId/tags"

querystring = {"offset":"0","limit":"20"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript Standard
const url = 'https://developer-stg.api.autodesk.com/schema/v3/tag-collections/tagCollectionId/tags?offset=0&limit=20';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Standard
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://developer-stg.api.autodesk.com/schema/v3/tag-collections/tagCollectionId/tags?offset=0&limit=20"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Standard
require 'uri'
require 'net/http'

url = URI("https://developer-stg.api.autodesk.com/schema/v3/tag-collections/tagCollectionId/tags?offset=0&limit=20")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Standard
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://developer-stg.api.autodesk.com/schema/v3/tag-collections/tagCollectionId/tags?offset=0&limit=20")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Standard
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://developer-stg.api.autodesk.com/schema/v3/tag-collections/tagCollectionId/tags?offset=0&limit=20', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Standard
using RestSharp;

var client = new RestClient("https://developer-stg.api.autodesk.com/schema/v3/tag-collections/tagCollectionId/tags?offset=0&limit=20");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Standard
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://developer-stg.api.autodesk.com/schema/v3/tag-collections/tagCollectionId/tags?offset=0&limit=20")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### No Category

**Response**

```json
{
  "pagination": {
    "limit": 20,
    "offset": 0,
    "nextUrl": "",
    "hasNext": false,
    "totalResults": 3
  },
  "results": [
    {
      "id": "ABVA-50841-HYPY-75617",
      "name": "Doors"
    },
    {
      "id": "ABVA-50841-HZUG-83173",
      "name": "Windows"
    }
  ]
}
```

**SDK Code**

```python No Category
import requests

url = "https://developer-stg.api.autodesk.com/schema/v3/tag-collections/tagCollectionId/tags"

querystring = {"offset":"0","limit":"20"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript No Category
const url = 'https://developer-stg.api.autodesk.com/schema/v3/tag-collections/tagCollectionId/tags?offset=0&limit=20';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go No Category
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://developer-stg.api.autodesk.com/schema/v3/tag-collections/tagCollectionId/tags?offset=0&limit=20"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby No Category
require 'uri'
require 'net/http'

url = URI("https://developer-stg.api.autodesk.com/schema/v3/tag-collections/tagCollectionId/tags?offset=0&limit=20")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java No Category
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://developer-stg.api.autodesk.com/schema/v3/tag-collections/tagCollectionId/tags?offset=0&limit=20")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php No Category
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://developer-stg.api.autodesk.com/schema/v3/tag-collections/tagCollectionId/tags?offset=0&limit=20', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp No Category
using RestSharp;

var client = new RestClient("https://developer-stg.api.autodesk.com/schema/v3/tag-collections/tagCollectionId/tags?offset=0&limit=20");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift No Category
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://developer-stg.api.autodesk.com/schema/v3/tag-collections/tagCollectionId/tags?offset=0&limit=20")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Tag with User Data and Mix of Category

**Response**

```json
{
  "pagination": {
    "limit": 20,
    "offset": 0,
    "nextUrl": "",
    "hasNext": false,
    "totalResults": 5
  },
  "results": [
    {
      "id": "ABVA-50841-HYPY-78617",
      "categoryId": "ABVA-48581-HKHB-90951",
      "name": "Doors",
      "userData": {
        "translations": {
          "ja-JP": "ドア"
        },
        "description": "This is the description for this Tag. Although there's no limit on the amount of characters but it is best practice to keep it as concise as possible."
      }
    },
    {
      "id": "ABVA-50841-HZUG-93173",
      "categoryId": "ABVA-49091-CGZP-54734",
      "name": "Windows",
      "userData": {
        "translations": {
          "ja-JP": "ウィンドウズ"
        },
        "description": "This is the description for this Tag. Although there's no limit on the amount of characters but it is best practice to keep it as concise as possible."
      }
    },
    {
      "id": "ABVA-50841-HZUG-83173",
      "name": "[No Category] Tag #1",
      "userData": {
        "description": "This is the description for this Tag. Although there's no limit on the amount of characters but it is best practice to keep it as concise as possible.",
        "ui": {
          "background": "FFFFFF",
          "foreground": "000000"
        }
      }
    }
  ]
}
```

**SDK Code**

```python Tag with User Data and Mix of Category
import requests

url = "https://developer-stg.api.autodesk.com/schema/v3/tag-collections/tagCollectionId/tags"

querystring = {"offset":"0","limit":"20"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript Tag with User Data and Mix of Category
const url = 'https://developer-stg.api.autodesk.com/schema/v3/tag-collections/tagCollectionId/tags?offset=0&limit=20';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Tag with User Data and Mix of Category
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://developer-stg.api.autodesk.com/schema/v3/tag-collections/tagCollectionId/tags?offset=0&limit=20"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Tag with User Data and Mix of Category
require 'uri'
require 'net/http'

url = URI("https://developer-stg.api.autodesk.com/schema/v3/tag-collections/tagCollectionId/tags?offset=0&limit=20")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Tag with User Data and Mix of Category
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://developer-stg.api.autodesk.com/schema/v3/tag-collections/tagCollectionId/tags?offset=0&limit=20")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Tag with User Data and Mix of Category
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://developer-stg.api.autodesk.com/schema/v3/tag-collections/tagCollectionId/tags?offset=0&limit=20', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Tag with User Data and Mix of Category
using RestSharp;

var client = new RestClient("https://developer-stg.api.autodesk.com/schema/v3/tag-collections/tagCollectionId/tags?offset=0&limit=20");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Tag with User Data and Mix of Category
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://developer-stg.api.autodesk.com/schema/v3/tag-collections/tagCollectionId/tags?offset=0&limit=20")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```